#include "fullscreen.h"
#include "dialogfullsceen.h"

SceenFull::SceenFull()
{
    this->setObjectName(trUtf8("Aqua-fullScreen"));
    QDir appDir(qApp->applicationDirPath());

#if defined(Q_OS_WIN)

  //  if (appDir.dirName().toLower() == "debug" || appDir.dirName().toLower() == "release")
    appDir.cdUp();
  appPath=  appDir.absolutePath()+"/share/elforkane";
#elif defined(Q_OS_MAC)
    if (appDir.dirName() == "MacOS") {
        appDir.cdUp();
        appDir.cdUp();
        appDir.cdUp();
            appPath=  appDir.absolutePath()+"/elforkane";
    }
#else
    appDir.cdUp();
    appPath=  appDir.absolutePath()+"/share/elforkane";
   // qDebug()<<appPath;
#endif
    loadSetting();


    sceen=new QGraphicsScene;
    createSceen();
     //   setBackground();
  }

  SceenFull::~SceenFull()
  {
      stopAnimation();
      saveSetting();
  }


  void SceenFull::setGraphicSceen(QGraphicsView *view)
  {
         view->setScene(sceen);
          setBackground();
  }

  void SceenFull::createSceen()
  {

      pixBgr=new QGraphicsPixmapItem() ;
      pixBgrBack=new QGraphicsPixmapItem ;
      panelReflect=new QGraphicsWidget ;
      zekhrafaRondedTop=new QGraphicsWidget ;

      panelAya=new  QGraphicsWidget;
      itemAya= new   QGraphicsPixmapItem (panelAya);
      pageAya= new QGraphicsPixmapItem (panelAya);

      sceen->addItem(pixBgr);
      sceen->addItem(pixBgrBack);

      sceen->addItem(panelReflect);
      creatItemAnim();

      sceen->addItem(panelAya);


      createTopPanel();
      creatBotPanel();


  }

    void  SceenFull::creatItemAnim()
    {
        QPixmap pixaqua(":/image/reflet.png");
        QPixmap pixaqua2(":/image/reflet2.png");
        for(int i=0;i<3;i++){
            myref[i]=new Pixmap(pixaqua);
            myref2[i]=new Pixmap(pixaqua2);
            myRain[i]=new Pixmap(QPixmap(":/image/aqua.png"));
            myref3[i]=new Pixmap(QPixmap(":/image/aqua3.png"));

            sceen->addItem(myref[i]);
            sceen->addItem(myref2[i]);
            sceen->addItem(myRain[i]);
            sceen->addItem(myref3[i]);

            myRain[i]->setGeometry(QRect(0,0,10,16));

            myref[i]->setOpacity(0);
            myref2[i]->setOpacity(0);
            myref3[i]->setOpacity(0);
              myRain[i]->setOpacity(0);
        }
         timer0=new QTimer(this);
        timer1=new QTimer(this);
        timer2=new QTimer(this);
     connect(timer0, SIGNAL(timeout()), this, SLOT(setAnim0()));
        connect(timer1, SIGNAL(timeout()), this, SLOT(setAnim1()));
           connect(timer2, SIGNAL(timeout()), this, SLOT(setAnim2()));

    }
    void SceenFull::setAnim0()
    {
        int w=QApplication::desktop()->geometry().width();
        int h=QApplication::desktop()->geometry().height();
       int htop=(h/3)*2;

        int rndx=w-100;
        int rndxX=rand() % ++rndx;
         int x=50+rndxX;

         int rndy=(h/3)-80;
         int rndxY=rand() % ++rndy;
        int y=htop+20+rndxY;
         animRain(0,x,y);

         int rn=2000;
         int rndI=rand() % ++rn;
       timer0->setInterval(2750+rndI);
  //qDebug()<<"rnd1 :"+QString::number(rndy);
    }
  void SceenFull::setAnim1()
  {
      int w=QApplication::desktop()->geometry().width();
      int h=QApplication::desktop()->geometry().height();
     int htop=(h/3)*2;

      int rndx=w-100;
      int rndxX=rand() % ++rndx;
       int x=50+rndxX;

       int rndy=(h/3)-80;
       int rndxY=rand() % ++rndy;
      int y=htop+20+rndxY;
       animRain(1,x,y);

       int rn=2000;
       int rndI=rand() % ++rn;
     timer1->setInterval(2750+rndI);
  //   ()<<"rnd1 :"+QString::number(rndI);
  }
  void SceenFull::setAnim2()
  {

      int w=QApplication::desktop()->geometry().width();
      int h=QApplication::desktop()->geometry().height();
     int htop=(h/3)*2;

      int rndx=w-100;
      int rndxX=rand() % ++rndx;
       int x=50+rndxX;

       int rndy=(h/3)-80;
       int rndxY=rand() % ++rndy;
      int y=htop+20+rndxY;
       animRain(2,x,y);

       int rn=2000;
       int rndI=rand() % ++rn;
      timer2->setInterval(2750+rndI);
        //qDebug()<<"rnd2 :"+QString::number(rndX);
  }
  void SceenFull::createTopPanel()
  {
      int w=QApplication::desktop()->geometry().width();

      QGraphicsWidget  * panelTop=new QGraphicsWidget ;
      QGraphicsPixmapItem   *itemPanelTop= new   QGraphicsPixmapItem (panelTop);
      itemBlurTop=new QGraphicsWidget (panelTop);
      QPixmap pix(w,60);
      pix.fill(Qt::transparent);
      QPainter p;
      p.begin(&pix);

      p.fillRect(0,0,w,60,QColor(255, 255, 255, 100));
            p.setPen(QColor(128, 128, 128,200));
            p.drawLine(0,59,pix.width(),59);
            p.setPen(QColor(255, 255, 255,150));
            p.drawLine(0,58,pix.width(),58);
      //رسم زخارف في الاعلى

      p.end();

      itemPanelTop->setPixmap(pix);

      QGraphicsDropShadowEffect *efet=new QGraphicsDropShadowEffect;
      efet->setOffset(0,5);
      efet->setColor((QColor(64, 64,64,255)))  ;
      efet->setBlurRadius(10);
      panelTop->setGraphicsEffect(efet);

      labelInfo=new QLabel();
      labelInfo->setGeometry(0,10,w,40);
      labelInfo->setAlignment(Qt::AlignHCenter|Qt::AlignVCenter);
      QString labStyle="QLabel { font: bold 18px;color: white;background-color: rgba(255, 255, 255, 0);border: 0px;}";
      labelInfo->setStyleSheet(labStyle);

      sceen->addItem(panelTop);
      sceen->addWidget(labelInfo);
  }
  void SceenFull::creatBotPanel()
  {
      int w=QApplication::desktop()->geometry().width();
      int h=QApplication::desktop()->geometry().height();
      QGraphicsWidget  * panelBot=new QGraphicsWidget ;
      QGraphicsPixmapItem   *itemPanelBot= new   QGraphicsPixmapItem (panelBot);
      QPixmap pix(w,60);
      pix.fill(Qt::transparent);
      QPainter p;
      p.begin(&pix);

      p.fillRect(0,0,w,60,QColor(255, 255, 255, 100));
      p.setPen(QColor(128, 128, 128,150));
      p.drawLine(0,0,pix.width(),0);

      p.setPen(QColor(255, 255, 255,150));
      p.drawLine(0,1,pix.width(),1);

    p.end();
      p.end();
      itemPanelBot->setPixmap(pix);
      QGraphicsDropShadowEffect *efet=new QGraphicsDropShadowEffect;
      efet->setOffset(0,-5);
      efet->setColor((QColor(63, 63, 63,200)))  ;
      efet->setBlurRadius(10);
      panelBot->setGraphicsEffect(efet);

      panelBot->setPos(0,h-60);
      labelTrans=new QLabel;
      labelTrans->setGeometry(0,h-50,w,45);
      labelTrans->setAlignment(Qt::AlignHCenter);
       labelTrans->setWordWrap(true);
      QString labStyle="QLabel { font: bold 14px;color:rgb(64, 64, 64);background-color: rgba(255, 255, 255, 0);border: 0px;}";
    labelTrans->setStyleSheet(labStyle);

      sceen->addItem(panelBot);
        sceen->addWidget(labelTrans);
  }


void SceenFull::animAya()
{
   QPropertyAnimation *anim = new QPropertyAnimation(panelAya, "opacity");
    anim->setDuration(700);
    anim->setStartValue(0.5);
    anim->setEndValue(1.0);
    anim->start();
}
  void SceenFull::setInfo(QString sura,QString  jozaa,QString hizb,QString rbaa,QString aya,QString reciter,QString trans)
  {
      labelInfo->setText(sura+
                      jozaa+
                        hizb+
                        rbaa+
                         aya+
                       reciter );
      labelTrans->setText(trans);
  }

 void  SceenFull::setPixmapAya(QPixmap pix)
 {

     // pageAya->setPos(w-pw,h-ph);
     //-------------------------------------------------------------

   //  panelAya->setOpacity(0.8);

     QPixmap pixmap(pix.width()+100,pix.height()+100);

     pixmap.fill(Qt::transparent);
QPainter p;
     p.begin(&pixmap);
     p.setRenderHint(QPainter::Antialiasing,true);

     p.setPen(QColor(128, 128, 128,255));
     QRectF rect(0.0,0.0,pix.width()+100,pix.height()+100);
     p.drawRoundedRect(rect,9.0,9.0);//رسم مربع بالرمادي
    QRectF rect2(1.0,1.0,pix.width()+97,pix.height()+97);
     p.setPen(QColor(255, 255, 255,255));
    p.setBrush(QColor(255, 255, 255, 80));//رسم لون شفاف على المساحة
    p.drawRoundedRect(rect2,7.0,7.0);//رسم مربع بالابيض نقطة بعد الرمادي
     p.end();

     itemAya->setPixmap(pixmap);
     int w=QApplication::desktop()->geometry().width()/2;
     int h=(QApplication::desktop()->geometry().height())/2;
     int pw=(pix.width()+100)/2;
     int ph=(pix.height()+100)/2;
     panelAya->setGeometry(w-pw,h-ph,pix.width()+100,pix.height()+100);
     QGraphicsDropShadowEffect *efet=new QGraphicsDropShadowEffect;
     efet->setOffset(8,8);
     efet->setColor((QColor(63, 63, 63,150)))  ;
     efet->setBlurRadius(25);
     panelAya->setGraphicsEffect(efet);

     pageAya->setPixmap(pix);
     pageAya->setPos(50,50);

    animAya();

 }

 void  SceenFull::setBackground()
 {
     int w=QApplication::desktop()->geometry().width();
     int h=QApplication::desktop()->geometry().height();

     QString curBgr;
     curBgr=m_fullbackground;
     if(!QFile::exists(m_fullbackground))
         curBgr=(appPath+"/fullscreen/bgrFull.png");

     QPixmap pix(w,h);
     QPixmap pix2(w,h);
     pix.fill(Qt::transparent);
     pix2.fill(Qt::transparent);
     QPainter p;
     int topH=(h/3);

     QTransform translationTransform(0.5, 0, 0, 0.5, -100,h+(topH/2));
     QTransform rotationTransform(0.5, 0.0, 0.0, 1,0,0);
     QTransform scalingTransform(5, 0, 0, -1.0, 0, 0);
     QTransform transform;
     transform = scalingTransform * rotationTransform * translationTransform;

     p.begin(&pix);
     p.drawPixmap(0,0,w,topH*2,QPixmap(curBgr));

     p.fillRect(0,topH*2,w,topH,QColor(64,64,64));

     p.end();

     p.begin(&pix2);

     p.setTransform(transform);
     p.drawPixmap(0,0,w,h,QPixmap(curBgr));


     p.end();
  p.begin(&pix2);
  QLinearGradient linearGrad(QPointF(w,0), QPointF(w,h));
  linearGrad.setColorAt(0,QColor(255, 255, 255, 100));
 linearGrad.setColorAt(0.7,QColor(55, 108, 255, 5));
  linearGrad.setColorAt(1, QColor(55, 108, 255, 180));
  p.setRenderHint(QPainter::Antialiasing,true);
  p.fillRect(0,topH*2,w,topH,linearGrad);
     p.end();
     pixBgr->setPixmap(pix);

     pixBgrBack->setPixmap(pix2);

     QGraphicsBlurEffect *efet=new QGraphicsBlurEffect;
     efet->setBlurHints(QGraphicsBlurEffect::QualityHint)  ;
     efet->setBlurRadius(15);

     pixBgrBack->setGraphicsEffect(efet);

 }
  void SceenFull::animRain(int index,int x,int y)
  {

curIndex=index;
      myRain[index]->setOpacity(1);

      QPropertyAnimation *animRain= new QPropertyAnimation(myRain[index], "pos");
      animRain->setDuration(750);

      animRain->setStartValue(QPointF(x,20));
      animRain->setEndValue(QPointF(x,y));
     // animRain->setLoopCount(index);
      //anim2->setEasingCurve(QEasingCurve::InOutQuad);
    connect(animRain, SIGNAL(finished()), myRain[index], SLOT(setHide()));
   //QTimer::singleShot(750,myRain[index],QChar(property("hide").toChar()));


      QPropertyAnimation *anim = new QPropertyAnimation(myref[index], "opacity");
      anim->setDuration(1000);
      anim->setStartValue(0.0);
      anim->setEndValue(1.0);
      anim->setEasingCurve(QEasingCurve::SineCurve);
      QPropertyAnimation *anim2= new QPropertyAnimation(myref[index], "geometry");
      anim2->setDuration(750);

      anim2->setStartValue(QRect(x,y,10,10));
      anim2->setEndValue(QRect(x-15,y-15,40,40));

      anim2->setEasingCurve(QEasingCurve::OutQuad);


      //------------------------------------
      QPropertyAnimation *anim3 = new QPropertyAnimation(myref2[index], "opacity");
      anim3->setDuration(2000);
      anim3->setStartValue(0.0);
      anim3->setEndValue(0.7);
      anim3->setEasingCurve(QEasingCurve::SineCurve);
      QPropertyAnimation *anim4= new QPropertyAnimation(myref2[index], "geometry");
      anim4->setDuration(2000);

      anim4->setStartValue(QRect(x,y,10,10));
      anim4->setEndValue(QRect(x-35,y-35,80,80));
      anim4->setEasingCurve(QEasingCurve::OutQuad);

      //-------------------------------------------------
      QPropertyAnimation *anim5 = new QPropertyAnimation(myref3[index], "opacity");
      anim5->setDuration(750);
      anim5->setStartValue(0.0);
      anim5->setEndValue(1.0);
      anim5->setEasingCurve(QEasingCurve::SineCurve);
      QPropertyAnimation *anim6= new QPropertyAnimation(myref3[index], "geometry");
      anim6->setDuration(500);

      anim6->setStartValue(QRect(x,y+20,10,0));
      anim6->setEndValue(QRect(x-1,y-12,12,40));
      //   anim6->setEasingCurve(QEasingCurve::SineCurve);
      QSequentialAnimationGroup *groupRain=new QSequentialAnimationGroup;
      QParallelAnimationGroup *grouAqua=new QParallelAnimationGroup;

      grouAqua->addAnimation(anim);
      grouAqua->addAnimation(anim2);
      grouAqua->addAnimation(anim3);
      grouAqua->addAnimation(anim4);
      grouAqua->addAnimation(anim5);
      grouAqua->addAnimation(anim6);

      groupRain->addAnimation(animRain);
      groupRain->addAnimation(grouAqua);
      groupRain->start();

  }

 void SceenFull::animAqua(int index)
 {
    myRain[index]->setOpacity(0);

 }

  void SceenFull::stopAnimation()
  {
   timer0->stop();
      timer1->stop();
     timer2->stop();
  }
  void SceenFull::setAnimationEnabled(bool enable)
  {

     if(enable==true){
          timer0->start();
         timer1->start();
           timer2->start();
     }else{
            timer0->stop();
         timer1->stop();
           timer2->stop();
     }
  }
  void SceenFull::execOptions()
  {
      Dialogfullsceen *dlgFull=new Dialogfullsceen(0);
      dlgFull->setBackground(m_fullbackground);
      if (dlgFull->exec() == QDialog::Accepted){
          m_fullbackground=dlgFull->bgrDir;
      }
  }

  void SceenFull::loadSetting()
  {
      QSettings settings(QDir::homePath()+"/.elforkane/fulScreen.ini",QSettings::IniFormat);
      settings.beginGroup("FullScreen");
      m_fullbackground=settings.value("fullbackground",appPath+"/fullscreen/bgrFull.png").toString();
      settings.endGroup();
  }

  void SceenFull::saveSetting()
  {
      QSettings settings(QDir::homePath()+"/.elforkane/fulScreen.ini",QSettings::IniFormat);
      settings.beginGroup("FullScreen");
      settings.setValue("fullbackground", m_fullbackground);
      settings.endGroup();
  }

Q_EXPORT_PLUGIN2(elforkane_fsAqua, SceenFull);
